﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AlarmClock
{
    class Alarm:IComparable
    {
        String Hour, Min, Day, Month, Year;
        
        int hour, min;
        int day, month, year;
        String alarmMessage;

        //regular alarm
        public Alarm(String calendar, String m)
        {
            if (m.Length <= 200) alarmMessage = m;
            else alarmMessage = m.Substring(0, 200);
            parseNormal(calendar);
            //System.Console.WriteLine("" + day + " " + month + " " + year + " " + hour + ":" + min);
        }

        public Alarm(String y, String M, String d, String h, String m, String mes)
        {
            Hour = h;
            Min = m;
            Year = y;
            Month = M;
            Day = d;

            hour = Int32.Parse(Hour);
            min = Int32.Parse(Min);
            year = Int32.Parse(Year);
            month = Int32.Parse(Month);
            day = Int32.Parse(Day);

            if (mes.Length <= 200) alarmMessage = mes;
            else alarmMessage = mes.Substring(0, 200);

        }


       
        //converts a text string to an alarm object
        public void parseNormal(String c)
        {
            System.Console.WriteLine(c);
            String data = c;
            String remainder = "";
            int space = c.IndexOf("/");
            String m = c.Substring(0, space);
            remainder = c.Substring(space+1);
            this.month = Int32.Parse(m);
            Month = m;
            space = remainder.IndexOf("/");
            Day = remainder.Substring(0, space); // data contains the day
            remainder = remainder.Substring(space+1);//remainder contains the year onwards
            this.day = Int32.Parse(Day);

            space = remainder.IndexOf(" ");
            Year = remainder.Substring(0, space); //data contains year
            remainder = remainder.Substring(space + 1); // remainder contains the time
            this.year = Int32.Parse(Year);

            space = remainder.IndexOf(":");
            Hour = remainder.Substring(0, space); //data contains hour
            remainder = remainder.Substring(space + 1); // remainder contains the min
            this.hour = Int32.Parse(Hour);

            space = remainder.IndexOf(":");
            Min = remainder.Substring(0, space); //data contains min
            remainder = remainder.Substring(remainder.Length -2); // remainder contains the AM/PM
            this.min = Int32.Parse(Min);

        }

        //returns a data of fixed length for sending to mcu
        //format yyyyMMddHHmm
        public string DateInfo()
        {
            String s = Year + Month + Day + Hour + Min;
            //System.Console.Write(s);
            return s;
        }

        public string MessageInfo(){
            return alarmMessage;
        }

        public override string  ToString()
        {
            String s = "" + month + "/" + day + "/" + year + " " + hour + ":" + min + "      " + alarmMessage ;
            return s;
        }       

        public override bool Equals(object obj)
        {
            if (obj == null || !(obj is Alarm)) return false;

            Alarm a = (Alarm) obj;
            return (a.month == this.month) && (a.day == this.day) && (a.year == this.year) && (a.min == this.min) && (a.hour == this.hour);
        }
        //sorts alarms by date
        public int CompareTo(object obj)
        {
            Alarm a = (Alarm)obj;
            if (this.year < a.year) return -1;
            else if (this.year > a.year) return 1;
            else
            {

                if (this.month < a.month) return -1;
                else if (this.month > a.month) return 1;
                //months are equal, compare day
                else
                {
                    if (this.day < a.day) return -1;
                    else if (this.day > a.day) return 1;
                    // days are equal
                    else
                    {
                        if (this.hour < a.hour) return -1;
                        else if (this.hour > a.hour) return 1;
                        else
                        {
                            if (this.min < a.min) return -1;
                            else if (this.min > a.min) return 1;
                            else return 0;
                        }
                    }
                }
            }
        }
       
    }
}
