﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AlarmClock
{
    public partial class Form1 : Form
    {

        List<Alarm> normalAlarms = new List<Alarm>();
        List<WeeklyAlarm> weeklyAlarms = new List<WeeklyAlarm>();
        SerialCom sc;
        String normalAlarmDateTime = "";
        String normalAlarmMessage = "";
        String comport = "";
        String hour = "";
        String min = "";
        public Form1()
        {
            InitializeComponent();
            
        }

        //button to click to initialise comport
        private void button1_Click(object sender, EventArgs e)
        {

            try
            {
                if (sc != null && sc.sp.IsOpen) sc.sp.Close();
                System.Console.WriteLine(comport);
                sc = new SerialCom(comport);
                sc.sp.Open();
            }
            catch
            {
                textBox5.Text = "Error initialisiing port";
            }
                normalAlarms = new List<Alarm>();
                weeklyAlarms = new List<WeeklyAlarm>();
                DisplayAlarms();

        }

        //Textbox for initialising COMPORT
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            comport = textBox1.Text;
        }

        //Textbox for entering normal alarm messages
        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            normalAlarmMessage = textBox3.Text;
        }

        //button for submitting alarms
        private void button3_Click(object sender, EventArgs e)
        {
            // create a new normal alarm and add it to the normal alarm list
            Alarm a = new Alarm(dateTimePicker2.Text, textBox3.Text);
            if (!normalAlarms.Contains(a))
            {
                System.Console.WriteLine("added alarm");
                normalAlarms.Add(a);
                normalAlarms.Sort();
            }
            DisplayAlarms();
           
            
        }

        //For picking the date and time for normal alarms
        private void dateTimePicker2_ValueChanged(object sender, EventArgs e)
        {
            normalAlarmDateTime = dateTimePicker2.Text;
        }

        //Textbox for displaying for alarms
        private void textBox5_TextChanged(object sender, EventArgs e)
        {
            textBox5.WordWrap = true;

        }
        //to display messages
        public void DisplayAlarms()
        {
            String s = "Normal Alarms\r\n";
            foreach (Alarm a in normalAlarms)
            {
                s = s + a.ToString() + "\r\n";
            }

            s = s + "\r\nWeekly Alarms\r\n";
            foreach (WeeklyAlarm wa in weeklyAlarms)
            {
                s = s + wa.ToString() + "\r\n";
            }
            textBox5.Text = s;

        }

        //button to talk to MCU and obtain alarms from it
        private void button6_Click(object sender, EventArgs e)
        {
            //Get stuff from MCU and display it

            //First clear the list
            normalAlarms.Clear();
            weeklyAlarms.Clear();

            sc.GetAlarms(normalAlarms, weeklyAlarms);


            DisplayAlarms();
        }

        //Button to create a new weekly alarm
        private void button4_Click(object sender, EventArgs e)
        {
            //create a new weekly Alarm and add it to the list
            if (domainUpDown1.Text.Equals("Day of the week"))
            {
                System.Console.WriteLine("error: Please pick a day of the week");
            }
            else
            {
                WeeklyAlarm wa = new WeeklyAlarm(domainUpDown1.Text, dateTimePicker1.Text, textBox4.Text);
                if (!weeklyAlarms.Contains(wa))
                {
                    weeklyAlarms.Add(wa);
                    weeklyAlarms.Sort();
                    System.Console.WriteLine("alarm added");
                }
            }
            DisplayAlarms();

        }

     //button to reset alarms
        private void button5_Click(object sender, EventArgs e)
        {
            normalAlarms.Clear();
            weeklyAlarms.Clear();
            textBox5.Text = "NormalAlarms\r\n \r\nWeeklyAlarms";

        }

        //button to send alarm to MCU
        private void button7_Click(object sender, EventArgs e)
        {
            sc.SendAlarms(normalAlarms, weeklyAlarms);
        }

     
        //button to delect an alarm
        private void button8_Click(object sender, EventArgs e)
        {
            if (domainUpDown2.Text.Equals("Event Alarm"))
            {
                if (!(comboBox1.Text.Equals("Number")))
                {
                    int i;
                    try
                    {
                        i = Int32.Parse(comboBox1.Text);
                        if (normalAlarms.Count >= i)
                        {
                            normalAlarms.RemoveAt(i - 1);
                            normalAlarms.Sort();
                        }
                    }
                    catch
                    {
                        System.Console.WriteLine("error");
                    }
                    
                }
            }
            else
            {
                if (!(comboBox1.Text.Equals("Number")))
                {
                    try
                    {
                        int i = Int32.Parse(comboBox1.Text);
                        if (weeklyAlarms.Count >= i)
                        {
                            weeklyAlarms.RemoveAt(i - 1);
                            weeklyAlarms.Sort();
                        }
                    }
                    catch
                    {
                        
                    }
                }
            }
            System.Console.WriteLine("hello");
            DisplayAlarms();
        }


       
    }
}
