﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AlarmClock
{
    class WeeklyAlarm: IComparable
    {
        String Weekday = "";
        String Hour, Min;
        int weekday; // the day of the week it occurs on
        int hour, min;
        String alarmMessage;

        public WeeklyAlarm(String weekDayN, String h, String m, String mes)
        {
            if (mes.Length <= 200) alarmMessage = mes;
            else alarmMessage = mes.Substring(0, 200);
            weekday = Int32.Parse(weekDayN);
            Weekday = WeekdayNumToText(weekday);

            Hour = h;
            Min = m;
            hour = Int32.Parse(Hour);
            min = Int32.Parse(Min);
        }



         public WeeklyAlarm(String weekDay, String time, String m)
        {
            if (m.Length <= 200) alarmMessage = m;
            else alarmMessage = m.Substring(0, 200);
            Weekday = weekDay;
            parseWeekly(weekDay, time);
            System.Console.WriteLine(this.ToString());
        }

         public String WeekdayNumToText(int wd)
         {
             String s = "";
             switch (wd)
             {
                 case 1:
                     s = "Monday";
                     break;
                 case 2:
                     s = "Tuesday";
                     break;
                 case 3:
                     s = "Wednesday";
                     break;
                 case 4:
                     s = "Thursday";
                     break;
                 case 5:
                     s = "Friday";
                     break;
                 case 6:
                     s = "Saturday";
                     break;
                 case 0:
                     s = "Sunday";
                     break;
                 default:
                     s = "" + wd;
                     break;

             }
             return s;

         }

        //converts text to an alarm object
         public void parseWeekly(String wd, String t)
         {
             switch (wd)
             {
                 case "Monday": 
                     weekday = 1;
                     break;
                 case "Tuesday":
                     weekday = 2;
                     break;
                 case "Wednesday":
                     weekday = 3;
                     break;
                 case "Thursday":
                     weekday = 4;
                     break;
                 case "Friday":
                     weekday = 5;
                     break;
                 case "Saturday":
                     weekday = 6;
                     break;
                 case "Sunday":
                     weekday = 0;
                     break;
                 default:
                     weekday = 7; // error message
                     break;
             }

             int space;
             String remainder = t;
             
             space = remainder.IndexOf(":");
            Hour = remainder.Substring(0, space); //data contains hour
            remainder = remainder.Substring(space + 1); // remainder contains the min
            this.hour = Int32.Parse(Hour);

            space = remainder.IndexOf(":");
            Min = remainder.Substring(0, space); //data contains min
            remainder = remainder.Substring(remainder.Length -2); // remainder contains the AM/PM
            this.min = Int32.Parse(Min);
 
        }

         public string dayInfo()
         {
             String s = "";
             s = "" + weekday + "" + Hour + Min;
             System.Console.Write(s);
             return s;
         }

         public string MessageInfo()
         {
             return alarmMessage;
         }

         public override string ToString()
         {
             String s = "" + Weekday + " " + hour + ":" + min + "      " + alarmMessage;
             return s;
         }

         public override bool Equals(object obj)
         {
             if (obj == null || !(obj is WeeklyAlarm)) return false;

             WeeklyAlarm a = (WeeklyAlarm)obj;
             return (a.weekday == weekday) &&(a.min == this.min) && (a.hour == this.hour);
         }

         public int CompareTo(object obj)
         {
             WeeklyAlarm a = (WeeklyAlarm)obj;
             if (this.weekday < a.weekday) return -1;
             else if (this.weekday > a.weekday) return 1;
             else
             {
    
                         if (this.hour < a.hour) return -1;
                         else if (this.hour > a.hour) return 1;
                         else
                         {
                             if (this.min < a.min) return -1;
                             else if (this.min > a.min) return 1;
                             else return 0;
                         }
             }
         }

    }
}
